/*
 * NFACommon.cpp
 *
 *  Created on: 16. 1. 2014
 *	  Author: Jan Vesely
 */

#include "NFACommon.h"
#include "label/LabelSetLabel.h"

#include <deque>
#include <algorithm>
#include <iostream>

namespace automaton {

namespace determinize {

label::Label createDFAState ( std::set < label::Label > nfaStates ) {
	return label::Label ( label::LabelSetLabel ( std::move ( nfaStates ) ) );
}

const std::set < label::Label > & recreateNFAStates ( const label::Label & dfaState ) {
	 // std::cout << dfaState << std::endl;
	return static_cast < const label::LabelSetLabel & > ( dfaState.getData ( ) ).getData ( );
}

} /* namespace determinize */

} /* namespace automaton */
