/*
 * AutomataIntersectionCartesianProduct.h
 *
 *  Created on: 20. 11. 2014
 *	  Author: Tomas Pecka
 */

#ifndef AUTOMATA_INTERSECTION_CARTESIAN_H_
#define AUTOMATA_INTERSECTION_CARTESIAN_H_

#include <core/multipleDispatch.hpp>
#include <automaton/Automaton.h>
#include <automaton/FSM/EpsilonNFA.h>

namespace automaton {

namespace transform {

/**
 * Intersection of two automata.
 *  - For finite automata A1, A2, we create automaton L accepting L(A1) \cap L(A2) (Melichar, 2.75)
 */
class AutomataIntersectionCartesianProduct : public std::PromotingDoubleDispatch<AutomataIntersectionCartesianProduct, automaton::Automaton, const automaton::AutomatonBase &> {
public:
	static automaton::Automaton intersection(const automaton::Automaton& first, const automaton::Automaton& second);

	static automaton::NFA < > intersection(const automaton::NFA < > & first, const automaton::NFA < > & second);
	static automaton::DFA<> intersection(const automaton::DFA<>& first, const automaton::DFA<>& second);
};

} /* namespace transform */

} /* namespace automaton */

#endif /* AUTOMATA_INTERSECTION_CARTESIAN_H_ */
