/*
 * Rename.h
 *
 *  Created on: Sep 27, 2016
 *      Author: Tomas Pecka
 */

#ifndef RENAME_GRAMMAR_H_
#define RENAME_GRAMMAR_H_

#include <core/multipleDispatch.hpp>
#include <grammar/Grammar.h>
#include <grammar/Regular/LeftRG.h>
#include <grammar/Regular/RightRG.h>

namespace grammar {

namespace simplify {

class Rename : public std::SingleDispatch < Rename, grammar::Grammar, const grammar::GrammarBase & > {
public:
	/**
	 * @param grammar grammar to rename
	 */
	static grammar::Grammar rename ( const grammar::Grammar & grammar );

	static grammar::RightRG < > rename ( const grammar::RightRG < > & grammar );
	static grammar::LeftRG < > rename ( const grammar::LeftRG < > & grammar );
};

} /* namespace simplify */

} /* namespace grammar */

#endif /* RENAME_GRAMMAR_H_ */
