/*
 * ExactSubtreeRepeatsNaive.h
 *
 *  Created on: 5. 11. 2014
 *      Author: Jan Travnicek
 */

#ifndef _ARBOLOGY_SUBTREE_REPEATS_NAIVE_H_
#define _ARBOLOGY_SUBTREE_REPEATS_NAIVE_H_

#include <tree/TreeFeatures.h>
#include <alphabet/SymbolFeatures.h>
#include <core/multipleDispatch.hpp>

#include <map>
#include <vector>
#include <tree>
#include <alphabet/RankedSymbol.h>

namespace tree {

namespace properties {

/**
 * Simple computation of subtree repeats
 */
class ExactSubtreeRepeatsNaive : public std::SingleDispatch < ExactSubtreeRepeatsNaive, tree::Tree, const tree::TreeBase & > {
	static std::tree < std::ranked_symbol < > > repeats ( const std::tree < std::ranked_symbol < > > & node, std::map < std::pair < std::ranked_symbol < >, std::vector < std::ranked_symbol < > > >, int > & data, int & minId );
	static std::ranked_symbol < > repeatsPrefixRanked ( const std::vector < std::ranked_symbol < > > & symbols, std::vector < std::ranked_symbol < > > & res, std::map < std::pair < std::ranked_symbol < >, std::vector < std::ranked_symbol < > > >, int > & data, int & minId, int & index );
	static std::ranked_symbol < > repeatsPrefixRankedBar ( const std::vector < std::ranked_symbol < > > & symbols, std::vector < std::ranked_symbol < > > & res, std::map < std::pair < std::ranked_symbol < >, std::vector < std::ranked_symbol < > > >, int > & data, int & minId, int & index );

public:
	/**
	 * Compute a same shaped tree with nodes containing unique subtree ids.
	 * @return Tree of repeats
	 */
	static tree::Tree repeats ( const tree::Tree & pattern );

	/**
	 * Compute a same shaped tree with nodes containing unique subtree ids.
	 * @return Tree of repeats
	 */
	static tree::RankedTree < > repeats ( const tree::RankedTree < > & tree );
	static tree::PrefixRankedTree < > repeats ( const tree::PrefixRankedTree < > & tree );
	static tree::PrefixRankedBarTree < > repeats ( const tree::PrefixRankedBarTree < > & tree );

};

} /* namespace properties */

} /* namespace tree */

#endif /* _ARBOLOGY_SUBTREE_REPEATS_NAIVE_H_ */
