#include <list>
#include "minimizeTest.h"

#include "automaton/simplify/Minimize.h"

#define CPPUNIT_IMPLY(x, y) CPPUNIT_ASSERT(!(x) || (y))

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( minimizeTest, "automaton" );
CPPUNIT_TEST_SUITE_REGISTRATION( minimizeTest );

void minimizeTest::setUp() {
}

void minimizeTest::tearDown() {
}

void minimizeTest::testMinimize() {
  automaton::DFA < > automaton(DefaultStateType(1));

  automaton.addState(DefaultStateType(1));
  automaton.addState(DefaultStateType(2));
  automaton.addState(DefaultStateType(3));
  automaton.addInputSymbol(DefaultSymbolType("a"));
  automaton.addInputSymbol(DefaultSymbolType("b"));
  
  automaton.addTransition(DefaultStateType(1), DefaultSymbolType("a"), DefaultStateType(2));
  automaton.addTransition(DefaultStateType(2), DefaultSymbolType("b"), DefaultStateType(1));

  automaton.addFinalState(DefaultStateType(3));
  
  automaton::DFA<> minimized = automaton::simplify::Minimize::minimize(automaton);

  CPPUNIT_ASSERT(minimized.getStates().size() == 3);

}
