#include <list>
#include "normalizeTest.h"

#include "automaton/simplify/Normalize.h"

#define CPPUNIT_IMPLY(x, y) CPPUNIT_ASSERT(!(x) || (y))

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( normalizeTest, "automaton" );
CPPUNIT_TEST_SUITE_REGISTRATION( normalizeTest );

void normalizeTest::setUp() {
}

void normalizeTest::tearDown() {
}

void normalizeTest::testNormalize() {
  automaton::DFA < > automaton(DefaultStateType(0));

  automaton.addState(DefaultStateType(0));
  automaton.addState(DefaultStateType(1));
  automaton.addState(DefaultStateType(2));
  automaton.addInputSymbol(DefaultSymbolType("a"));
  automaton.addInputSymbol(DefaultSymbolType("b"));
  
  automaton.addTransition(DefaultStateType(0), DefaultSymbolType("a"), DefaultStateType(1));
  automaton.addTransition(DefaultStateType(1), DefaultSymbolType("b"), DefaultStateType(2));

  automaton.addFinalState(DefaultStateType(2));
  
  automaton::DFA<> normalized = automaton::simplify::Normalize::normalize(automaton);

  CPPUNIT_ASSERT(normalized.getStates().size() == 3);

  CPPUNIT_ASSERT(automaton == normalized);
}
