/*
 * Author: Radovan Cerveny
 */

#ifndef STRINGOLOGY_BACKWARD_ORACLE_MATCHING_H__
#define STRINGOLOGY_BACKWARD_ORACLE_MATCHING_H__

#include <string/String.h>
#include <string/StringFeatures.h>
#include <core/multipleDispatch.hpp>

#include <set>

namespace stringology {

namespace exact {

/**
 * Implementation of Backward Oracle Matching.
 */
class BackwardOracleMatching : public std::DoubleDispatch <BackwardOracleMatching, std::set < unsigned >, const string::StringBase &, const string::StringBase & > {
public:
    /**
     * Search for pattern in linear string.
     * @return set set of occurences
     */
    static std::set < unsigned > match ( const string::String & subject, const string::String & pattern );
    static std::set < unsigned > match ( const string::LinearString < > & subject, const string::LinearString < > & pattern );

};

} /* namespace exact */

} /* namespace stringology */

#endif /* STRINGOLOGY_BACKWARD_ORACLE_MATCHING_H__ */
