#ifndef LR0_PARSER_TEST_H_
#define LR0_PARSER_TEST_H_

#include "grammar/ContextFree/CFG.h"
#include "alphabet/Symbol.h"

#include <cppunit/extensions/HelperMacros.h>

class LR0Parser : public CppUnit::TestFixture {
	CPPUNIT_TEST_SUITE ( LR0Parser );
	CPPUNIT_TEST ( testClosure );
	CPPUNIT_TEST ( testNextStateItems );
	CPPUNIT_TEST ( testAutomaton );
	CPPUNIT_TEST_SUITE_END ( );

	DefaultSymbolType E = DefaultSymbolType ( 'E' );
	DefaultSymbolType T = DefaultSymbolType ( 'T' );
	DefaultSymbolType F = DefaultSymbolType ( 'F' );

	DefaultSymbolType plus = DefaultSymbolType ( '+' );
	DefaultSymbolType times = DefaultSymbolType ( '*' );
	DefaultSymbolType leftParenthesis = DefaultSymbolType ( '(' );
	DefaultSymbolType rightParenthesis = DefaultSymbolType ( ')' );
	DefaultSymbolType identifier = DefaultSymbolType ( "id" );

	grammar::CFG < > getExpressionGrammar ( );

public:
	void setUp ( );
	void tearDown ( );

	void testClosure ( );
	void testNextStateItems ( );
	void testAutomaton ( );
};

#endif /* LR0_PARSER_TEST_H_ */
