#ifndef SLR1_PARSE_TABLE_TEST_H_
#define SLR1_PARSE_TABLE_TEST_H_

#include "grammar/ContextFree/CFG.h"
#include "alphabet/Symbol.h"

#include <cppunit/extensions/HelperMacros.h>

class SLR1ParseTable : public CppUnit::TestFixture {
	CPPUNIT_TEST_SUITE ( SLR1ParseTable );
	CPPUNIT_TEST ( testActionTable );
	CPPUNIT_TEST ( testGotoTable );
	CPPUNIT_TEST ( testUnambiguousNotSLR1Grammar );
	CPPUNIT_TEST_SUITE_END ( );

	DefaultSymbolType E = DefaultSymbolType ( 'E' );
	DefaultSymbolType T = DefaultSymbolType ( 'T' );
	DefaultSymbolType F = DefaultSymbolType ( 'F' );

	DefaultSymbolType plus = DefaultSymbolType ( '+' );
	DefaultSymbolType times = DefaultSymbolType ( '*' );
	DefaultSymbolType leftParenthesis = DefaultSymbolType ( '(' );
	DefaultSymbolType rightParenthesis = DefaultSymbolType ( ')' );
	DefaultSymbolType identifier = DefaultSymbolType ( "id" );

	grammar::CFG < > getExpressionGrammar ( );

public:
	void setUp ( );
	void tearDown ( );

	void testActionTable ( );
	void testGotoTable ( );
	void testUnambiguousNotSLR1Grammar ( );
};

#endif /* SLR1_PARSE_TABLE_TEST_H_ */
