/*
 * Primitive.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef PRIMITIVE_H_
#define PRIMITIVE_H_

#include <base/WrapperBase.hpp>
#include "PrimitiveBase.h"

namespace primitive {

/**
 * Wrapper around primitive data types.
 */
class Primitive : public alib::WrapperBase < PrimitiveBase > {
	using alib::WrapperBase < PrimitiveBase >::WrapperBase;

public:
	explicit Primitive ( int number );
	explicit Primitive ( char character );
	explicit Primitive ( std::string string );
	explicit Primitive ( const char * string );
	explicit Primitive ( unsigned number );
	explicit Primitive ( bool value );

	void inc ( );

	static const std::string & getXmlTagRefName() {
		static std::string xmlTagName = "PrimitiveRef";

		return xmlTagName;
	}
};

} /* namespace primitive */

#endif /* PRIMITIVE_H_ */
