/*
 * Grammar.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Martin Zak
 */

#ifndef GRAMMAR_H_
#define GRAMMAR_H_

#include <base/WrapperBase.hpp>
#include "GrammarBase.h"

#include <type_traits>

namespace grammar {

/**
 * Wrapper around grammars.
 */
class Grammar : public alib::WrapperBase < GrammarBase > {
	using alib::WrapperBase < GrammarBase >::WrapperBase;

public:
	static const std::string & getXmlTagRefName() {
		static std::string xmlTagName = "GrammarRef";

		return xmlTagName;
	}
};

template < class T >
using SymbolTypeOfGrammar = typename std::decay < decltype (std::declval<T>().getNonterminalAlphabet()) >::type::value_type;

} /* namespace grammar */

#endif /* GRAMMAR_H_ */
