/*
 * String.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef STRING_H_
#define STRING_H_

#include <base/WrapperBase.hpp>
#include "StringBase.h"
#include <set>
#include <vector>
#include <common/DefaultSymbolType.h>

namespace string {

/**
 * Wrapper around strings.
 */
class String : public alib::WrapperBase < StringBase > {
	using alib::WrapperBase < StringBase >::WrapperBase;

public:
	static const std::string & getXmlTagRefName() {
		static std::string xmlTagName = "StringRef";

		return xmlTagName;
	}
};

string::String stringFrom ( const DefaultSymbolType & symbol );
string::String stringFrom ( const std::string & str );
string::String stringFrom ( const char * str );
string::String stringFrom ( const std::vector < DefaultSymbolType > & str );

} /* namespace string */

#endif /* STRING_H_ */
