/*
 * StringAuxiliary.h
 *
 *  Created on: May 7, 2016
 *      Author: Jan Travnicek
 */

#ifndef STRING_AUXILIARY_H_
#define STRING_AUXILIARY_H_

#include <set>
#include <vector>
#include <common/DefaultSymbolType.h>
#include "../../alphabet/ranked_symbol.hpp"
#include "../../alphabet/RankedSymbol.h"

namespace string {

/**
 * Parser used to get string from XML parsed into list of Tokens.
 */
class StringAuxiliary {
public:
	static std::vector < DefaultSymbolType > toInternal ( const std::string & rawString );

	template < class SymbolType, class RankType >
	static std::vector < DefaultSymbolType > wrapSymbols ( const std::vector < std::ranked_symbol < SymbolType, RankType > > & ranked );
	template < class SymbolType, class RankType >
	static std::set < DefaultSymbolType > wrapSymbols ( const std::set < std::ranked_symbol < SymbolType, RankType > > & ranked );
};

template < class SymbolType, class RankType >
std::vector < DefaultSymbolType > StringAuxiliary::wrapSymbols ( const std::vector < std::ranked_symbol < SymbolType, RankType > > & ranked ) {
	return std::transform < DefaultSymbolType > ( ranked, [&] ( const std::ranked_symbol < SymbolType, RankType > & symbol) {
			return DefaultSymbolType ( alphabet::RankedSymbol < SymbolType, RankType > ( symbol ) );
	} );
}

template < class SymbolType, class RankType >
std::set < DefaultSymbolType > StringAuxiliary::wrapSymbols ( const std::set < std::ranked_symbol < SymbolType, RankType > > & ranked ) {
	return std::transform < DefaultSymbolType > ( ranked, [&] ( const std::ranked_symbol < SymbolType, RankType > & symbol) {
			return DefaultSymbolType ( alphabet::RankedSymbol < SymbolType, RankType > ( symbol ) );
	} );
}

} /* namespace string */

#endif /* STRING_AUXILIARY_H_ */
