/*
 * PrefixBarTree.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "PrefixBarTree.h"
#include "../Tree.h"
#include "../UnrankedTreeWrapper.h"
#include <object/Object.h>
#include <core/xmlApi.hpp>
#include <core/castApi.hpp>

namespace alib {

auto prefixBarTreeParserRegister = xmlApi < tree::Tree >::ParserRegister < tree::PrefixBarTree < > > ( );
auto prefixBarTreeParserRegister2 = xmlApi < tree::UnrankedTreeWrapper >::ParserRegister < tree::PrefixBarTree < > > ( );
auto prefixBarTreeParserRegister3 = xmlApi < alib::Object >::ParserRegister < tree::PrefixBarTree < > > ( );

auto PrefixBarTreeFromUnrankedTree = castApi::CastRegister < tree::PrefixBarTree < > , tree::UnrankedTree < > > ( );
auto PrefixBarTreeCastBinder = castApi::CastPoolStringBinder < tree::PrefixBarTree < > > ( tree::PrefixBarTree < >::getXmlTagName() );

} /* namespace alib */
