/*
 * Author: Radovan Cerveny
 */

#ifndef MEASUREMENT_PROVISIONER_RESULTS_HPP_
#define MEASUREMENT_PROVISIONER_RESULTS_HPP_

#include <measure>
#include <ostream>

namespace measurements {

struct MPRPipelineCommandResult {
	std::string		   command;
	MeasurementResults measurementResults;
};

struct MPRPipelineStatus {
	int			exitCode;
	std::string errorOrigin;
	std::string errorValue;
};

struct MPRPipelineResult {
	MPRPipelineStatus						 pipelineStatus;
	std::vector < MPRPipelineCommandResult > commandResults;
};

struct MPRInputResult {
	std::vector < std::pair < int, std::string > > inputs;
	std::vector < MPRPipelineResult >			   pipelineResults;
};

struct MeasurementProvisionerResults {
	std::vector < MPRInputResult > inputResults;
};

std::ostream & operator <<( std::ostream &, const MeasurementProvisionerResults & );
}

#endif /* MEASUREMENT_PROVISIONER_RESULTS_HPP_ */
