/*
 * TreeToRawComposer.cpp
 *
 *  Created on: Nov 16, 2014
 *      Author: Jan Travnicek
 */

#include <tree/TreeException.h>
#include <tree/TreeClasses.h>
#include "TreeToRawComposer.h"

namespace tree {

void TreeToRawComposer::compose(std::deque<sax::Token>& out, const Tree& tree) {
	dispatch(out, tree.getData());
}

template < class SymbolType, class RankType >
void TreeToRawComposer::compose(std::deque<sax::Token>& out, const RankedTree < SymbolType, RankType > & tree) {
	composeNode(out, tree.getContent());
}

auto TreeToRawComposerRankedTree = TreeToRawComposer::RegistratorWrapper<void, RankedTree < > >(TreeToRawComposer::compose);

template < class SymbolType, class RankType >
void TreeToRawComposer::compose(std::deque<sax::Token>& out, const PrefixRankedTree < SymbolType, RankType > & tree) {
	unsigned i = 0;
	composePrefixRankedNotation(out, i, tree.getContent());
}

auto TreeToRawComposerPrefixRankedTree = TreeToRawComposer::RegistratorWrapper<void, PrefixRankedTree < > >(TreeToRawComposer::compose);

template < class SymbolType >
void TreeToRawComposer::compose(std::deque<sax::Token>& out, const PrefixRankedBarTree < SymbolType > & tree) {
	unsigned i = 0;
	composePrefixRankedBarNotation(out, i, tree.getContent());
}

auto TreeToRawComposerPrefixRankedBarTree = TreeToRawComposer::RegistratorWrapper<void, PrefixRankedBarTree < > >(TreeToRawComposer::compose);

template < class SymbolType >
void TreeToRawComposer::compose(std::deque<sax::Token>& out, const UnrankedTree < SymbolType > & tree) {
	composeNode(out, tree.getContent());
}

auto TreeToRawComposerUnrankedTree = TreeToRawComposer::RegistratorWrapper<void, UnrankedTree < > >(TreeToRawComposer::compose);

} /* namespace automaton */

