/*
 * PrimitiveToStringComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef PRIMITIVE_TO_STRING_COMPOSER_H_
#define PRIMITIVE_TO_STRING_COMPOSER_H_

#include <ostream>
#include <core/multipleDispatch.hpp>
#include "primitive/Primitive.h"
#include "primitive/PrimitiveFeatures.h"

namespace primitive {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class PrimitiveToStringComposer : public std::SingleDispatchFirstStaticParam<PrimitiveToStringComposer, void, std::ostream&, const PrimitiveBase &> {
public:
	static void compose(std::ostream&, const Integer& primitive);
	static void compose(std::ostream&, const String& primitive);
	static void compose(std::ostream&, const Character& primitive);
	static void compose(std::ostream&, const Unsigned& primitive);
	static void compose(std::ostream&, const Bool& primitive);

	/**
	 * Prints text representation of Primitive to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	static void compose(std::ostream& out, const Primitive& string);
};

} /* namespace primitive */

#endif /* PRIMITIVE_TO_STRING_COMPOSER_H_ */
