/*
 * RegExpToStringComposer.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Martin Zak
 */

#include "RegExpToStringComposer.h"

namespace regexp {

template < class SymbolType >
void RegExpToStringComposer::compose(std::ostream& output, const UnboundedRegExp < SymbolType > & regexp) {
	RegExpToStringComposer::compose ( output, regexp.getRegExp ( ) );
}

auto RegExpToStringComposerUnboundedRegExp = RegExpToStringComposer::RegistratorWrapper<void, UnboundedRegExp < > >(RegExpToStringComposer::compose);
auto ObjectToStringComposerUnboundedRegExp = alib::ObjectBaseDispatcher::RegistratorWrapper<void, UnboundedRegExp < > >( RegExpToStringComposer::compose);

template < class SymbolType >
void RegExpToStringComposer::compose(std::ostream& output, const FormalRegExp < SymbolType > & regexp) {
	RegExpToStringComposer::compose ( output, regexp.getRegExp ( ) );
}

auto RegExpToStringComposerFormalRegExp = RegExpToStringComposer::RegistratorWrapper<void, FormalRegExp < > >(RegExpToStringComposer::compose);
auto ObjectToStringComposerFormalRegExp = alib::ObjectBaseDispatcher::RegistratorWrapper<void, FormalRegExp < > >( RegExpToStringComposer::compose);

void RegExpToStringComposer::compose(std::ostream& output, const RegExp& regexp) {
	dispatch(output, regexp.getData());
}

auto ObjectToStringComposerRegExp = alib::WrapperBaseDispatcher::RegistratorWrapper<void, RegExp>(RegExpToStringComposer::compose);

} /* namespace regexp */
