#include "ObjectTest.h"

#include <label/Label.h>
#include <factory/StringDataFactory.hpp>
#include <object/ObjectToStringComposer.h>

#include <sstream>

#define CPPUNIT_EXCLUSIVE_OR(x, y) CPPUNIT_ASSERT((!(x) && (y)) || ((x) && !(y)))

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( ObjectTest, "label" );
CPPUNIT_TEST_SUITE_REGISTRATION( ObjectTest );

void ObjectTest::setUp() {
}

void ObjectTest::tearDown() {
}

void ObjectTest::testComposing() {
	std::string input = "<1, 2>";
	label::Label label = alib::StringDataFactory::fromString<label::Label>(input);

	std::string output = alib::StringDataFactory::toString(label);
	CPPUNIT_ASSERT( input == output );

	std::stringstream out;
	alib::ObjectToStringComposer::compose ( out, label.getData ( ) );
	std::string output2 = out.str();
	CPPUNIT_ASSERT( input == output2 );

	std::stringstream out2;
	alib::ObjectToStringComposer::compose ( out2, label );
	std::string output3 = out2.str();
	CPPUNIT_ASSERT( input == output3 );
}

